package com.playlet.web.controller.system;

import java.util.List;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.playlet.common.annotation.Log;
import com.playlet.common.enums.BusinessType;
import com.playlet.system.domain.PlayletMessage;
import com.playlet.system.service.IPlayletMessageService;
import com.playlet.common.core.controller.BaseController;
import com.playlet.common.core.domain.AjaxResult;
import com.playlet.common.utils.poi.ExcelUtil;
import com.playlet.common.core.page.TableDataInfo;

/**
 * 短剧公告Controller
 *
 * @author ruoyi
 * @date 2024-03-10
 */
@Controller
@RequestMapping("/system/playletMessage")
public class PlayletMessageController extends BaseController
{
    private String prefix = "system/playlet/message";

    @Autowired
    private IPlayletMessageService playletMessageService;

    @RequiresPermissions("playlet:message:view")
    @GetMapping()
    public String message()
    {
        return prefix + "/message";
    }

    /**
     * 查询短剧公告列表
     */
    @RequiresPermissions("playlet:message:list")
    @PostMapping("/list")
    @ResponseBody
    public TableDataInfo list(PlayletMessage playletMessage)
    {
        startPage();
        List<PlayletMessage> list = playletMessageService.selectPlayletMessageList(playletMessage);
        return getDataTable(list);
    }

    /**
     * 导出短剧公告列表
     */
    @RequiresPermissions("playlet:message:export")
    @Log(title = "短剧公告", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    @ResponseBody
    public AjaxResult export(PlayletMessage playletMessage)
    {
        List<PlayletMessage> list = playletMessageService.selectPlayletMessageList(playletMessage);
        ExcelUtil<PlayletMessage> util = new ExcelUtil<PlayletMessage>(PlayletMessage.class);
        return util.exportExcel(list, "短剧公告数据");
    }

    /**
     * 新增短剧公告
     */
    @GetMapping("/add")
    public String add()
    {
        return prefix + "/add";
    }

    /**
     * 新增保存短剧公告
     */
    @RequiresPermissions("playlet:message:add")
    @Log(title = "短剧公告", businessType = BusinessType.INSERT)
    @PostMapping("/add")
    @ResponseBody
    public AjaxResult addSave(PlayletMessage playletMessage)
    {
        return toAjax(playletMessageService.insertPlayletMessage(playletMessage));
    }

    /**
     * 修改短剧公告
     */
    @RequiresPermissions("playlet:message:edit")
    @GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") Long id, ModelMap mmap)
    {
        PlayletMessage playletMessage = playletMessageService.selectPlayletMessageById(id);
        mmap.put("playletMessage", playletMessage);
        return prefix + "/edit";
    }

    /**
     * 修改保存短剧公告
     */
    @RequiresPermissions("playlet:message:edit")
    @Log(title = "短剧公告", businessType = BusinessType.UPDATE)
    @PostMapping("/edit")
    @ResponseBody
    public AjaxResult editSave(PlayletMessage playletMessage)
    {
        return toAjax(playletMessageService.updatePlayletMessage(playletMessage));
    }

    /**
     * 删除短剧公告
     */
    @RequiresPermissions("playlet:message:remove")
    @Log(title = "短剧公告", businessType = BusinessType.DELETE)
    @PostMapping( "/remove")
    @ResponseBody
    public AjaxResult remove(String ids)
    {
        return toAjax(playletMessageService.deletePlayletMessageByIds(ids));
    }
}
